var NAVTREE =
[
  [ "Aria", "index.html", [
    [ "ARIA Developer's Reference Manual", "index.html", [
      [ "Contents", "index.html#toc", [
        [ "Additional tools in the ARIA toolbox:", "index.html#tocToolbox", null ],
        [ "Helpful information about C++ development with ARIA:", "index.html#tocDevHelp", null ],
        [ "Advanced Usage:", "index.html#tocAdv", null ]
      ] ],
      [ "Introduction", "index.html#intro", [
        [ "What is ARIA? How does it relate to other MobileRobots software?", "index.html#whouses", null ],
        [ "Java and Python", "index.html#javapython", null ],
        [ "Matlab", "index.html#matlab", null ]
      ] ],
      [ "License and Sharing", "index.html#licensing", null ],
      [ "The ARIA Package", "index.html#AriaPackage", [
        [ "ARIA/", "index.html#arpack", null ],
        [ "Other ARIA Files of Note", "index.html#arpackother", null ]
      ] ],
      [ "Documentation and Coding Convention", "index.html#codingConventions", null ],
      [ "ARIA-Robot Client-Server Relationship", "index.html#arCliServ", null ],
      [ "Robot Communication", "index.html#commClasses", [
        [ "Connecting with a Robot or the Simulator", "index.html#connectRobot", null ]
      ] ],
      [ "Specifying Details about Robot and Device Connections", "index.html#HardwareConfiguration", [
        [ "Robot Parameter Files", "index.html#RobotParameterFiles", null ],
        [ "Program Runtime Options", "index.html#RuntimeOptions", null ]
      ] ],
      [ "ArRobot", "index.html#robot", [
        [ "Client Commands and Server Information Packets", "index.html#commands", null ],
        [ "Packet Handlers", "index.html#packetHandlers", null ],
        [ "Command Packets", "index.html#CommandPackets", null ],
        [ "Robot Synchronization Cycle", "index.html#syncRobot", null ],
        [ "State Reflection", "index.html#stateReflection", null ],
        [ "Robot Callbacks", "index.html#callback", null ]
      ] ],
      [ "Controlling the robot with Commands and Actions", "index.html#ClientCommands", [
        [ "Direct Commands", "index.html#robotDirectCommands", null ],
        [ "Motion Command Functions", "index.html#robotMotionCommands", null ],
        [ "Actions", "index.html#actions", null ],
        [ "Action Desired", "index.html#actionDesired", null ],
        [ "The Action Resolver", "index.html#resolvers", null ],
        [ "Predefined Actions", "index.html#predefinedActions", null ],
        [ "Mixing Actions", "index.html#actionInteractions", null ],
        [ "Action Groups", "index.html#actionGroups", null ]
      ] ],
      [ "Range Devices", "index.html#rangeDevices", null ],
      [ "Functors", "index.html#functors", null ],
      [ "Keyboard and Joystick Input", "index.html#userInput", null ],
      [ "Threading", "index.html#threading", [
        [ "Thread Syncronizing Objects", "index.html#syncObject", null ],
        [ "Asynchronous Task Class", "index.html#asynctasks", null ]
      ] ],
      [ "Global Data", "index.html#aria", null ],
      [ "Device and Accessory Interface Classes", "index.html#devices", null ],
      [ "Utility Classes", "index.html#utility", null ],
      [ "ArConfig", "index.html#arconfig", null ],
      [ "Shared Info Groups", "index.html#arinfogroup", null ],
      [ "Maps", "index.html#maps", null ],
      [ "Sockets", "index.html#sockets", null ],
      [ "ArNetworking", "index.html#ArNetworking", null ],
      [ "Sound and Speech", "index.html#sound", null ],
      [ "Emacs", "index.html#emacs", null ],
      [ "Non-everyday use of C++", "index.html#noneverydayC", [
        [ "Standard Template Library", "index.html#stl", null ],
        [ "Default Arguments", "index.html#defaultArgs", null ],
        [ "Constructor Chaining", "index.html#constructorChaining", null ],
        [ "Chars and Strings, Win workaround", "index.html#charsAndStrings", null ],
        [ "AREXPORT", "index.html#arexport", null ],
        [ "Exceptions", "index.html#exceptions", null ]
      ] ],
      [ "Topics and Esoterica", "index.html#Advanced", [
        [ "Piecemeal Use of ARIA", "index.html#pieceMealUse", null ],
        [ "Connecting with a Robot or the Simulator the hard way", "index.html#hardConnectRobot", null ],
        [ "Opening the Connection", "index.html#openDevice", null ],
        [ "Robot Client-Server Connection", "index.html#devConnect", null ],
        [ "Connection Read, Write, Close and Timestamping", "index.html#connrw", null ]
      ] ]
    ] ],
    [ "Robot Parameter Files", "ParamFiles.html", [
      [ "Device Parameters", "ParamFiles.html#ParamFileDeviceParams", [
        [ "General Robot Parameters", "ParamFiles.html#ParamFileGeneralParams", null ],
        [ "Laser Rangefinding Devices", "ParamFiles.html#ParamFileLaserParams", null ],
        [ "GPS Devices", "ParamFiles.html#ParamFileGPSParams", null ],
        [ "Other Accessory Device Flags and Options", "ParamFiles.html#ParamFileOtherDeviceParams", null ]
      ] ]
    ] ],
    [ "Command Line Option Summary", "CommandLineOptions.html", [
      [ "ArRobotConnector", "CommandLineOptions.html#ArRobotConnector", null ],
      [ "ArLaserConnector", "CommandLineOptions.html#ArLaserConnector", null ],
      [ "ArPTZConnector", "CommandLineOptions.html#ArPTZConnector", null ],
      [ "ArGPSConnector", "CommandLineOptions.html#ArGPSConnector", null ],
      [ "ArCompassConnector", "CommandLineOptions.html#ArCompassConnector", null ],
      [ "ArSonarConnector", "CommandLineOptions.html#ArSonarConnector", null ]
    ] ],
    [ "Laser Scan Log File Format", "LaserLogFileFormat.html", null ],
    [ "Map File Format", "MapFileFormat.html", [
      [ "Defining Custom Map Objects", "MapFileFormat.html#MapCustomObjects", null ]
    ] ],
    [ "Deprecated List", "deprecated.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", null ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", "functions_eval" ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ],
    [ "Examples", "examples.html", "examples" ]
  ] ]
];

var NAVTREEINDEX =
[
"ArMD5Calculator_8h.html",
"classArActionAvoidSide.html#a0f858741d8a5b26d9e0a6b45227a51ed",
"classArActionDriveDistance.html#a99053bb92e7b3bc572cb27c537a8f298a0132d745b0cb4c13bc16625e93b10b09",
"classArActionKeydrive.html#a9b64b2514ce977e44b8cc5c57798f384",
"classArActionTriangleDriveTo.html#a1d204c6d37ce38249793cd5407102523a89e68ff809843d2d4c45b0590a80b40d",
"classArArgumentBuilder.html#a83120143347e3dbdb2891a37c75b8091",
"classArBatteryMTX.html#a56fda49cc2ef53e173857f0ecddcccb8",
"classArColor.html#a08106fcdc80b807ef10f3961a2f70ef5",
"classArConfig.html#ad1f538be210a0f6ae790217b9ea3533d",
"classArConstFunctor3C.html",
"classArDPPTU.html#a24ce83004c0343af062f435d03ede084",
"classArDeviceConnection.html#ab81bf283a2eec4beb64d2a428dccab99",
"classArFunctor5C.html#a74d6314919a98eb6a57eb5b561df7cb1",
"classArGPS.html#ace487fd8b428647fb0a6cb1ca2be6688",
"classArGlobalRetFunctor3.html#a8a202c009f3713b9cad6bab8ea1c7b73",
"classArJoyHandler.html#acbcfcb5fcfbfd22200b39b09c714a623",
"classArLCDMTX.html#adc99899477460393150fc518ae675152",
"classArLaser.html#a0d119529c9b0386408ef8b4896f673ce",
"classArLaser.html#a9bbdf1e01d6ce33fe8e5a5fce4ad29c0",
"classArLaserConnector_1_1LaserData.html#aa3313fe4c3164d4e653767b290f32d06",
"classArLineSegment.html#a1e7c9a96a559a0f0a5b2e1fc66719af8",
"classArMTXIO.html#a74d2256a902345ed574b20c63d959e08",
"classArMap.html#ad73c81af84da9c6dadfb5f5ad994bb52",
"classArMapInterface.html#a4721211e839289dc8ab24202e07471cc",
"classArMapSimple.html#a0c8f77bb5102599f1807229f0942dc86",
"classArModeActs.html#a3cd5e240e1d2f6678576c62f586c52fc",
"classArMutex.html",
"classArP2Arm.html#a7ac175f75bc05865c057fd9d1d281bdf",
"classArPTZ.html#ad3158b7894920926b3cbaf2e89d62d82",
"classArRVisionPTZ.html#afbee19ecd8b6bd3d49e2e3c8115aea57",
"classArRetFunctor1C.html#a7f1e68ab539a8c1116142087e07f0208",
"classArRobot.html#a1057659d8108eb3df28ea54abb4c6b58",
"classArRobot.html#a357d310f0ef17a881008bc772df5db24",
"classArRobot.html#a62a3af933d718789dbf5317975b6eec6",
"classArRobot.html#a99db61d9ed27d788f1ad1c90b428dbfd",
"classArRobot.html#ac8e29d5328e562c8522fe5ce4783c407",
"classArRobot.html#af7b30048ba2d7d0d7310d19fc8bbe07a",
"classArRobotConnector.html#a306ba3262fce29774cf7e655ca20b132",
"classArRobotParams.html#a49b8843f153058ef237904039370378d",
"classArSZSeries.html#a367ea0b85c235918d34585b6509e520f",
"classArSignalHandler.html",
"classArSonarConnector.html#a17c4dedbf2f29b44f04708d61db77ae2",
"classArSonyPTZ.html#a891ab2c6cde0d7f2a207e9f4d8670a38",
"classArSystemStatus.html#a5c91b50346a66c53f67c9f07a9c43b90",
"classArThread.html#a94f5c62be5ea634a63645b09d24618ea",
"classArUtil.html#a50fbd83a487dcf92689596c05e552533",
"classArVCC4.html#a7f6f21086079995077a65121dee602e0",
"classArVideoParams.html#a34ff0309d862c0eaa39d9923bbec3f60",
"functions_func_0x76.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

